Timers = {
    ActiveTimers = {},
}

Timers.add = function(delay, repeats, callback, args)
    local hours = getGameTime():getWorldAgeHours()
    local t = {
        delay = delay,
        callback = callback,
        args = args,
        repeats = repeats,
        trigger = hours + (delay/60),
    }
    t.id = ZombRand(100000) .."-".. t.trigger
    Timers.ActiveTimers[t.id] = t
    return t
end

Timers.remove = function(timer)
    if type(timer) == "table" then
        -- not a proper timer table
        if not timer.id then return end
        timer = timer.id
    end
    Timers.ActiveTimers[timer] = nil
end

Timers.check = function()
    local current = getGameTime():getWorldAgeHours()
    for id, timer in pairs(Timers.ActiveTimers) do
        if timer.trigger <= current then
            if not timer.repeats or timer.repeats == 0 then
                Timers.ActiveTimers[id] = nil
            elseif type(timer.repeats) == "number" then
                timer.repeats = timer.repeats - 1
            end
            timer.trigger = current + (timer.delay/60)
            timer.callback(timer, timer.args)
        end
    end
end
local lastMinute = nil
Events.OnTick.Add(function()
    local minute = getGameTime():getMinutes()
    if minute ~= lastMinute then
        Timers.check()
        lastMinute = minute
    end
end)
--Events.EveryTenMinutes.Add(Timers.check)
